"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getName(init) {
    return (init.name && init.name.replace(/[\W]+/g, "")) || (init.title && init.title.replace(/[\W_]+/g, ""));
}
function getTitle(init) {
    return (init.name && init.name.replace(/[\W_]+/g, " ")) || init.title || "";
}
class Factory {
    static rule(init) {
        const ruleInterface = init;
        const name = getName(init);
        const title = getTitle(init);
        if (!name) {
            throw new Error("Identifier needs a name value");
        }
        return {
            type: "Rule",
            title: title.trim(),
            name,
            id: ruleInterface.id || Math.floor(Math.random() * 10000000000000),
            dataType: ruleInterface.dataType || "string",
            aliases: ruleInterface.aliases,
            description: ruleInterface.description,
            sampleValue: ruleInterface.sampleValue,
            statedAs: ruleInterface.statedAs
        };
    }
    static aggregate(init) {
        const aggregateInterface = init;
        const name = getName(init);
        const title = getTitle(init);
        if (!name) {
            throw new Error("Identifier needs a name value");
        }
        return {
            facts: aggregateInterface.facts || [],
            type: "Aggregate",
            title: title.trim(),
            name,
            id: aggregateInterface.id || Math.floor(Math.random() * 10000000000000),
            version: aggregateInterface.version,
            description: aggregateInterface.description,
            decisionObjectType: aggregateInterface.decisionObjectType
        };
    }
}
exports.Factory = Factory;
//# sourceMappingURL=index.js.map